/**
 * oclazyload - Load modules on demand (lazy load) with angularJS
 * @version v0.6.0
 * @link https://github.com/ocombe/ocLazyLoad
 * @license MIT
 * @author Olivier Combe <olivier.combe@gmail.com>
 */
!function(){"use strict";function e(e){var n=[];return angular.forEach(e.requires,function(e){-1===l.indexOf(e)&&n.push(e)}),n}function n(e){if(!angular.isString(e))return!1;try{return y(e)}catch(n){if(/No module/.test(n)||n.message.indexOf("$injector:nomod")>-1)return!1}}function r(e){try{return y(e)}catch(n){throw(/No module/.test(n)||n.message.indexOf("$injector:nomod")>-1)&&(n.message='The module "'+e+'" that you are trying to load does not exist. '+n.message),n}}function a(e,n,r,a){if(n){var o,i,u,l;for(o=0,i=n.length;i>o;o++)if(u=n[o],angular.isArray(u)){if(null!==e){if(!e.hasOwnProperty(u[0]))throw new Error("unsupported provider "+u[0]);l=e[u[0]]}var s=t(u,r);if("invoke"!==u[1])s&&angular.isDefined(l)&&l[u[1]].apply(l,u[2]);else{var c=function(e){var n=f.indexOf(r+"-"+e);(-1===n||a)&&(-1===n&&f.push(r+"-"+e),angular.isDefined(l)&&l[u[1]].apply(l,u[2]))};if(angular.isFunction(u[2][0]))c(u[2][0]);else if(angular.isArray(u[2][0]))for(var d=0,g=u[2][0].length;g>d;d++)angular.isFunction(u[2][0][d])&&c(u[2][0][d])}}}}function o(e,n,r){if(n){var t,u,s,f=[];for(t=n.length-1;t>=0;t--)if(u=n[t],"string"!=typeof u&&(u=i(u)),u&&-1===c.indexOf(u)){var g=-1===l.indexOf(u);if(s=y(u),g&&(l.push(u),o(e,s.requires,r)),s._runBlocks.length>0)for(d[u]=[];s._runBlocks.length>0;)d[u].push(s._runBlocks.shift());angular.isDefined(d[u])&&(g||r.rerun)&&(f=f.concat(d[u])),a(e,s._invokeQueue,u,r.reconfig),a(e,s._configBlocks,u,r.reconfig),h(g?"ocLazyLoad.moduleLoaded":"ocLazyLoad.moduleReloaded",u),n.pop(),c.push(u)}var p=e.getInstanceInjector();angular.forEach(f,function(e){p.invoke(e)})}}function t(e,n){var r=e[2][0],a=e[1],o=!1;angular.isUndefined(s[n])&&(s[n]={}),angular.isUndefined(s[n][a])&&(s[n][a]={});var t=function(e,r){o=!0,s[n][a][e].push(r),h("ocLazyLoad.componentLoaded",[n,a,e])},i=function(e){return angular.isArray(e)?e.toString():angular.isObject(e)?JSON.stringify(e):angular.isDefined(e)&&null!==e?e.toString():e};if(angular.isString(r))angular.isUndefined(s[n][a][r])&&(s[n][a][r]=[]),-1===s[n][a][r].indexOf(i(e[2][1]))&&t(r,i(e[2][1]));else{if(!angular.isObject(r))return!1;angular.forEach(r,function(e){angular.isString(e)&&(angular.isUndefined(s[n][a][e])&&(s[n][a][e]=[]),-1===s[n][a][e].indexOf(i(r[1]))&&t(e,i(r[1])))})}return o}function i(e){var n=null;return angular.isString(e)?n=e:angular.isObject(e)&&e.hasOwnProperty("name")&&angular.isString(e.name)&&(n=e.name),n}function u(e){if(0===p.length){var n=[e],r=["ng:app","ng-app","x-ng-app","data-ng-app"],o=/\sng[:\-]app(:\s*([\w\d_]+);?)?\s/,t=function(e){return e&&n.push(e)};angular.forEach(r,function(n){r[n]=!0,t(document.getElementById(n)),n=n.replace(":","\\:"),e[0].querySelectorAll&&(angular.forEach(e[0].querySelectorAll("."+n),t),angular.forEach(e[0].querySelectorAll("."+n+"\\:"),t),angular.forEach(e[0].querySelectorAll("["+n+"]"),t))}),angular.forEach(n,function(n){if(0===p.length){var a=" "+e.className+" ",t=o.exec(a);t?p.push((t[2]||"").replace(/\s+/g,",")):angular.forEach(n.attributes,function(e){0===p.length&&r[e.name]&&p.push(e.value)})}})}0!==p.length||(window.jasmine||window.mocha)&&angular.isDefined(angular.mock)||console.error("No module found during bootstrap, unable to init ocLazyLoad. You should always use the ng-app directive or angular.boostrap when you use ocLazyLoad.");var i=function u(e){if(-1===l.indexOf(e)){l.push(e);var n=angular.module(e);a(null,n._invokeQueue,e),a(null,n._configBlocks,e),angular.forEach(n.requires,u)}};angular.forEach(p,function(e){i(e)}),p=[]}var l=["ng"],s={},f=[],c=[],d={},g=angular.module("oc.lazyLoad",["ng"]),h=angular.noop,p=[];g.provider("$ocLazyLoad",["$controllerProvider","$provide","$compileProvider","$filterProvider","$injector","$animateProvider",function(a,t,s,f,d,g){var m,v,y,L={},w={$controllerProvider:a,$compileProvider:s,$filterProvider:f,$provide:t,$injector:d,$animateProvider:g},j=document.getElementsByTagName("head")[0]||document.getElementsByTagName("body")[0],O=!1,E=!1;u(angular.element(window.document)),this.$get=["$log","$q","$templateCache","$http","$rootElement","$rootScope","$cacheFactory","$interval",function(a,t,u,s,f,d,g,x){var b,$=g("ocLazyLoad"),S=!1,D=!1;O||(a={},a.error=angular.noop,a.warn=angular.noop,a.info=angular.noop),w.getInstanceInjector=function(){return b?b:b=f.data("$injector")||angular.injector()},h=function(e,n){E&&d.$broadcast(e,n),O&&a.info(e,n)};var z=function(e,n,r){var a,o,i=t.defer(),u=function(e){var n=(new Date).getTime();return e.indexOf("?")>=0?"&"===e.substring(0,e.length-1)?e+"_dc="+n:e+"&_dc="+n:e+"?_dc="+n};switch(angular.isUndefined($.get(n))&&$.put(n,i.promise),e){case"css":a=document.createElement("link"),a.type="text/css",a.rel="stylesheet",a.href=r.cache===!1?u(n):n;break;case"js":a=document.createElement("script"),a.src=r.cache===!1?u(n):n;break;default:i.reject(new Error('Requested type "'+e+'" is not known. Could not inject "'+n+'"'))}a.onload=a.onreadystatechange=function(){a.readyState&&!/^c|loade/.test(a.readyState)||o||(a.onload=a.onreadystatechange=null,o=1,h("ocLazyLoad.fileLoaded",n),i.resolve())},a.onerror=function(){i.reject(new Error("Unable to load "+n))},a.async=r.serie?0:1;var l=j.lastChild;if(r.insertBefore){var s=angular.element(r.insertBefore);s&&s.length>0&&(l=s[0])}if(j.insertBefore(a,l),"css"==e){if(!S){var f=navigator.userAgent.toLowerCase();if(/iP(hone|od|ad)/.test(navigator.platform)){var c=navigator.appVersion.match(/OS (\d+)_(\d+)_?(\d+)?/),d=parseFloat([parseInt(c[1],10),parseInt(c[2],10),parseInt(c[3]||0,10)].join("."));D=6>d}else if(f.indexOf("android")>-1){var g=parseFloat(f.slice(f.indexOf("android")+8));D=4.4>g}else if(f.indexOf("safari")>-1&&-1==f.indexOf("chrome")){var p=parseFloat(f.match(/version\/([\.\d]+)/i)[1]);D=6>p}}if(D)var m=1e3,v=x(function(){try{a.sheet.cssRules,x.cancel(v),a.onload()}catch(e){--m<=0&&a.onerror()}},20)}return i.promise};angular.isUndefined(m)&&(m=function(e,n,r){var a=[];angular.forEach(e,function(e){a.push(z("js",e,r))}),t.all(a).then(function(){n()},function(e){n(e)})},m.ocLazyLoadLoader=!0),angular.isUndefined(v)&&(v=function(e,n,r){var a=[];angular.forEach(e,function(e){a.push(z("css",e,r))}),t.all(a).then(function(){n()},function(e){n(e)})},v.ocLazyLoadLoader=!0),angular.isUndefined(y)&&(y=function(e,n,r){var a=[];return angular.forEach(e,function(e){var n=t.defer();a.push(n.promise),s.get(e,r).success(function(r){angular.isString(r)&&r.length>0&&angular.forEach(angular.element(r),function(e){"SCRIPT"===e.nodeName&&"text/ng-template"===e.type&&u.put(e.id,e.innerHTML)}),angular.isUndefined($.get(e))&&$.put(e,!0),n.resolve()}).error(function(r){n.reject(new Error('Unable to load template file "'+e+'": '+r))})}),t.all(a).then(function(){n()},function(e){n(e)})},y.ocLazyLoadLoader=!0);var A=function(e,n){var r=[],o=[],i=[],u=[],l=null;angular.extend(n||{},e);var s=function(e){var t,s=null;if("object"==typeof e&&(s=e.type,e=e.path),l=$.get(e),angular.isUndefined(l)||n.cache===!1){if(null!==(t=/^(css|less|html|htm|js)?(?=!)/.exec(e))&&(s=t[1],e=e.substr(t[1].length+1,e.length)),!s)if(null!==(t=/[.](css|less|html|htm|js)?$/.exec(e)))s=t[1];else{if(m.hasOwnProperty("ocLazyLoadLoader")||!m.hasOwnProperty("load"))return void a.error("File type could not be determined. "+e);s="js"}"css"!==s&&"less"!==s||-1!==r.indexOf(e)?"html"!==s&&"htm"!==s||-1!==o.indexOf(e)?"js"===s||-1===i.indexOf(e)?i.push(e):a.error("File type is not valid. "+e):o.push(e):r.push(e)}else l&&u.push(l)};if(n.serie?s(n.files.shift()):angular.forEach(n.files,function(e){s(e)}),r.length>0){var f=t.defer();v(r,function(e){angular.isDefined(e)&&v.hasOwnProperty("ocLazyLoadLoader")?(a.error(e),f.reject(e)):f.resolve()},n),u.push(f.promise)}if(o.length>0){var c=t.defer();y(o,function(e){angular.isDefined(e)&&y.hasOwnProperty("ocLazyLoadLoader")?(a.error(e),c.reject(e)):c.resolve()},n),u.push(c.promise)}if(i.length>0){var d=t.defer();m(i,function(e){angular.isDefined(e)&&m.hasOwnProperty("ocLazyLoadLoader")?(a.error(e),d.reject(e)):d.resolve()},n),u.push(d.promise)}return n.serie&&n.files.length>0?t.all(u).then(function(){return A(e,n)}):t.all(u)};return{getModuleConfig:function(e){if(!angular.isString(e))throw new Error("You need to give the name of the module to get");return L[e]?L[e]:null},setModuleConfig:function(e){if(!angular.isObject(e))throw new Error("You need to give the module config object to set");return L[e.name]=e,e},getModules:function(){return l},isLoaded:function(e){var r=function(e){var r=l.indexOf(e)>-1;return r||(r=!!n(e)),r};if(angular.isString(e)&&(e=[e]),angular.isArray(e)){var a,o;for(a=0,o=e.length;o>a;a++)if(!r(e[a]))return!1;return!0}throw new Error("You need to define the module(s) name(s)")},load:function(u,l){var s,f,d=this,g=null,h=[],m=[],v=t.defer();if(angular.isUndefined(l)&&(l={}),angular.isArray(u))return angular.forEach(u,function(e){e&&m.push(d.load(e,l))}),t.all(m).then(function(){v.resolve(u)},function(e){v.reject(e)}),v.promise;if("string"==typeof u?(g=d.getModuleConfig(u),g||(g={files:[u]})):"object"==typeof u&&(g=angular.isDefined(u.path)&&angular.isDefined(u.type)?{files:[u]}:d.setModuleConfig(u)),null===g){var s=i(u);f='Module "'+(s||"unknown")+'" is not configured, cannot load.',a.error(f),v.reject(new Error(f))}else angular.isDefined(g.template)&&(angular.isUndefined(g.files)&&(g.files=[]),angular.isString(g.template)?g.files.push(g.template):angular.isArray(g.template)&&g.files.concat(g.template));h.push=function(e){-1===this.indexOf(e)&&Array.prototype.push.apply(this,arguments)};var y={};angular.extend(y,l,g);var L=function j(o){var u,l,s,f,c=[];if(u=i(o),null===u)return t.when();try{l=r(u)}catch(g){var p=t.defer();return a.error(g.message),p.reject(g),p.promise}return s=e(l),angular.forEach(s,function(e){if("string"==typeof e){var r=d.getModuleConfig(e);if(null===r)return void h.push(e);e=r}return n(e.name)?void("string"!=typeof o&&(f=e.files.filter(function(n){return d.getModuleConfig(e.name).files.indexOf(n)<0}),0!==f.length&&a.warn('Module "',u,'" attempted to redefine configuration for dependency. "',e.name,'"\n Additional Files Loaded:',f),c.push(A(e.files,y).then(function(){return j(e)})))):(angular.isArray(e)?e={files:e}:"object"==typeof e&&e.hasOwnProperty("name")&&e.name&&(d.setModuleConfig(e),h.push(e.name)),void(e.hasOwnProperty("files")&&0!==e.files.length&&e.files&&c.push(A(e,y).then(function(){return j(e)}))))}),t.all(c)};return A(g,y).then(function(){if(0===p.length)v.resolve(u);else{var e=function n(e){h.push(e),L(e).then(function(){try{c=[],o(w,h,y)}catch(e){return a.error(e.message),void v.reject(e)}p.length>0?n(p.shift()):v.resolve(u)},function(e){v.reject(e)})};e(p.shift())}},function(e){v.reject(e)}),v.promise}}}],this.config=function(e){if(angular.isDefined(e.jsLoader)||angular.isDefined(e.asyncLoader)){if(!angular.isFunction(e.jsLoader||e.asyncLoader))throw"The js loader needs to be a function";m=e.jsLoader||e.asyncLoader}if(angular.isDefined(e.cssLoader)){if(!angular.isFunction(e.cssLoader))throw"The css loader needs to be a function";v=e.cssLoader}if(angular.isDefined(e.templatesLoader)){if(!angular.isFunction(e.templatesLoader))throw"The template loader needs to be a function";y=e.templatesLoader}angular.isDefined(e.modules)&&(angular.isArray(e.modules)?angular.forEach(e.modules,function(e){L[e.name]=e}):L[e.modules.name]=e.modules),angular.isDefined(e.debug)&&(O=e.debug),angular.isDefined(e.events)&&(E=e.events)}}]),g.directive("ocLazyLoad",["$ocLazyLoad","$compile","$animate","$parse",function(e,n,r,a){return{restrict:"A",terminal:!0,priority:1e3,compile:function(o){var t=o[0].innerHTML;return o.html(""),function(o,i,u){var l=a(u.ocLazyLoad);o.$watch(function(){return l(o)||u.ocLazyLoad},function(a){angular.isDefined(a)&&e.load(a).then(function(){r.enter(n(t)(o),null,i)})},!0)}}}}]);var m=angular.bootstrap;angular.bootstrap=function(e,n,r){return p=n.slice(),m(e,n,r)};var v=function(e){angular.isString(e)&&-1===p.indexOf(e)&&p.push(e)},y=angular.module;if(angular.module=function(e,n,r){return v(e),y(e,n,r)},(window.jasmine||window.mocha)&&angular.isDefined(angular.mock)){{var L=angular.mock.module;window.module}window.module=angular.mock.module=function(e){Array.prototype.slice.call(arguments,0);angular.isObject(e)&&!angular.isArray(e)?angular.forEach(e,function(e,n){v(n)}):angular.isString(e)&&v(e),L(e)}}Array.prototype.indexOf||(Array.prototype.indexOf=function(e,n){var r;if(null==this)throw new TypeError('"this" is null or not defined');var a=Object(this),o=a.length>>>0;if(0===o)return-1;var t=+n||0;if(1/0===Math.abs(t)&&(t=0),t>=o)return-1;for(r=Math.max(t>=0?t:o-Math.abs(t),0);o>r;){if(r in a&&a[r]===e)return r;r++}return-1})}();